<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <script src="cifrado.js"></script>
    <script>
        function Cifra(){
            var texto = document.getElementById('cifrar').value;
            var textoCifrado = '';
            var arrayFinal = JSON.parse(cifrado);

            for(var i = 0; i < texto.length; i++){
                var existe = incluyeLetra(arrayFinal, texto[i].toUpperCase());

                if(existe >= 0){
                    textoCifrado += arrayFinal[existe].numero + ' ';
                }
                else{
                    textoCifrado += '*';
                }
            }
            
            document.getElementById('descifrar').value = textoCifrado;
        }

        function incluyeLetra(array, a){
            var posicion = -1;
            for(var i = 0; i < array.length; i++) {      
                if (array[i].letra == a) {
                    posicion = i;
                }
            }

            return posicion;
        }

        function incluyeNumero(array, a){
            var posicion = -1;
            for(var i = 0; i < array.length; i++) {      
                if (array[i].numero == a) {
                    posicion = i;
                }
            }

            return posicion;
        }

        function Descifra(){
            var texto = document.getElementById('descifrar').value;
            var textoDescifrado = '';
            var arrayFinal = JSON.parse(cifrado);
            var numeros = texto.split(' ');

            for(var i = 0; i < numeros.length; i++){
                var existe = incluyeNumero(arrayFinal, numeros[i]);
                if(existe >= 0){
                    textoDescifrado += arrayFinal[existe].letra;
                }
                else{
                    var cadena = numeros[i].length

                    for(var j = 0; j < cadena; j++){
                        textoDescifrado += '*';
                    }  
                }
            }
            
            document.getElementById('cifrar').value = textoDescifrado;
        }

    </script>
    <title>Cifra/Descifra</title>
</head>
<body>
    Texto a cifrar<textarea name="cifrar" cols="30" rows="10" id="cifrar"></textarea>
    <button onclick="Cifra()">Cifrar</button>
    Texto a descifrar<textarea name="descifrar" cols="30" rows="10" id="descifrar"></textarea>
    <button onclick="Descifra()">Descifrar</button>
</body>
</html>